#include<bits/stdc++.h>
using namespace std;
int read(){
	int x=0,f=1;
	char ch=getchar();
	while(ch<'0'||ch>'9'){
		if(ch=='-') f=-1;
		ch=getchar();
	}
	while(ch<='9'&&ch>='0'){
		x=(x<<3)+(x<<1)+(ch^48);
		ch=getchar();
	}
	return x*f;
}
const int N=800;
int w[N];
struct node{
	int opt,x,y;
}q[N];
int que[N*2],n,m,k;
void point(){
	memset(q,0,sizeof(q));
	int cnt=0,hh=0,tt=-1;
	for(int i=1;i<=m;i++){
		if(w[i]==w[i+1]){
			q[++cnt].opt=1,q[cnt].x=1;
			q[++cnt].opt=1,q[cnt].x=1;
			i++;
		}
		else{
			if(que[hh]==w[i]&&hh<=tt){
				hh++;q[++cnt].opt=1,q[cnt].x=2;
				q[++cnt].opt=2,q[cnt].x=1,q[cnt].y=2;
			}
			else{
				que[++tt]=w[i];
				q[++cnt].opt=1,q[cnt].x=1;
			}
		}
	}
	printf("%d\n",cnt);
	for(int i=1;i<=cnt;i++){
		if(q[i].opt==1){
			printf("1 %d\n",q[i].x);
		}
		else {
			printf("2 %d %d\n",q[i].x,q[i].y);
		}
	}
}
bool vis1[N],vis2[N];
//void point2(){
//	memset(q,0,sizeof(q));
//	int cnt=0,hh=0,tt=-1;
//	for(int i=1;i<=m;i++){
//		if(w[i]==w[i+1]){
//			q[++cnt].opt=1,q[cnt].x=1;
//			q[++cnt].opt=1,q[cnt].x=1;
//			i++;
//		}
//	}
//}
int main(){
	freopen("meow.in","r",stdin);
	freopen("meow.out","w",stdout);
	int T=read();
	while(T--){
		n=read(),m=read(),k=read();
		for(int i=1;i<=m;i++) w[i]=read();
		if(n==2) point();
//		else if(n==3) point2();
	}
	return 0;
}